<?php

Yii::import('application.modules.core_models.models._base.BaseModel');

/**
 * This is the model base class for the table "product_element_source_confidence".
 * DO NOT MODIFY THIS FILE! It is automatically generated by giix.
 * If any changes are necessary, you must set or override the required
 * property or method in class "ProductElementSourceConfidence".
 *
 * Columns in table "product_element_source_confidence" available as properties of the model,
 * followed by relations of table "product_element_source_confidence" available as properties of the model.
 *
 * @property integer $id
 * @property integer $data_source_id
 * @property integer $product_element_id
 * @property integer $confidence_score
 * @property string $query
 * @property integer $enabled
 *
 * @property ProductElement $productElement
 * @property DataSource $dataSource
 */
abstract class BaseProductElementSourceConfidence extends BaseModel
{

    public static function model($className = __CLASS__)
    {
        return parent::model($className);
    }

    public function tableName()
    {
        return 'product_element_source_confidence';
    }

    public static function label($n = 1)
    {
        return Yii::t('app', 'ProductElementSourceConfidence|ProductElementSourceConfidences', $n);
    }

    public static function representingColumn()
    {
        return 'query';
    }

    public function rules()
    {
        return array(
            array('id, data_source_id, product_element_id', 'required'),
            array('id, data_source_id, product_element_id, confidence_score, enabled', 'numerical', 'integerOnly'=>true),
            array('query', 'safe'),
            array('confidence_score, query, enabled', 'default', 'setOnEmpty' => true, 'value' => null),
            array('id, data_source_id, product_element_id, confidence_score, query, enabled', 'safe', 'on'=>'search'),
        );
    }

    public function relations()
    {
        return array(
            'productElement' => array(self::BELONGS_TO, 'ProductElement', 'product_element_id'),
            'dataSource' => array(self::BELONGS_TO, 'DataSource', 'data_source_id'),
        );
    }

    public function pivotModels()
    {
        return array(
        );
    }

    public function attributeLabels()
    {
        return array(
            'id' => Yii::t('app', 'ID'),
            'data_source_id' => null,
            'product_element_id' => null,
            'confidence_score' => Yii::t('app', 'Confidence Score'),
            'query' => Yii::t('app', 'Query'),
            'enabled' => Yii::t('app', 'Enabled'),
            'productElement' => null,
            'dataSource' => null,
        );
    }

    public function search()
    {
        $criteria = new CDbCriteria;

        $criteria->compare('id', $this->id);
        $criteria->compare('data_source_id', $this->data_source_id);
        $criteria->compare('product_element_id', $this->product_element_id);
        $criteria->compare('confidence_score', $this->confidence_score);
        $criteria->compare('query', $this->query, true);
        $criteria->compare('enabled', $this->enabled);

        return new CActiveDataProvider($this, array(
            'criteria' => $criteria, 'pagination' => array('pageSize' => 100)
        ));
    }

}
